# coding: utf-8

"""
    Quay Frontend

    This API allows you to perform many of the operations required to work with Quay repositories, users, and organizations.  # noqa: E501

    OpenAPI spec version: v1
    Contact: support@quay.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from quayio_sdk.api_client import ApiClient


class SearchApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def conduct_repo_search(self, **kwargs):  # noqa: E501
        """conduct_repo_search  # noqa: E501

        Get a list of apps and repositories that match the specified query.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.conduct_repo_search(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param bool include_usage: Whether to include usage metadata
        :param int page: The page.
        :param str query: The search query.
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.conduct_repo_search_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.conduct_repo_search_with_http_info(**kwargs)  # noqa: E501
            return data

    def conduct_repo_search_with_http_info(self, **kwargs):  # noqa: E501
        """conduct_repo_search  # noqa: E501

        Get a list of apps and repositories that match the specified query.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.conduct_repo_search_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param bool include_usage: Whether to include usage metadata
        :param int page: The page.
        :param str query: The search query.
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['include_usage', 'page', 'query']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method conduct_repo_search" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'include_usage' in params:
            query_params.append(('includeUsage', params['include_usage']))  # noqa: E501
        if 'page' in params:
            query_params.append(('page', params['page']))  # noqa: E501
        if 'query' in params:
            query_params.append(('query', params['query']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/api/v1/find/repositories', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def conduct_search(self, **kwargs):  # noqa: E501
        """conduct_search  # noqa: E501

        Get a list of entities and resources that match the specified query.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.conduct_search(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str query: The search query.
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.conduct_search_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.conduct_search_with_http_info(**kwargs)  # noqa: E501
            return data

    def conduct_search_with_http_info(self, **kwargs):  # noqa: E501
        """conduct_search  # noqa: E501

        Get a list of entities and resources that match the specified query.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.conduct_search_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str query: The search query.
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['query']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method conduct_search" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'query' in params:
            query_params.append(('query', params['query']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # Authentication setting
        auth_settings = ['oauth2_implicit']  # noqa: E501

        return self.api_client.call_api(
            '/api/v1/find/all', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_matching_entities(self, prefix, **kwargs):  # noqa: E501
        """get_matching_entities  # noqa: E501

        Get a list of entities that match the specified prefix.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_matching_entities(prefix, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str prefix:  (required)
        :param bool include_orgs: Whether to include orgs names.
        :param bool include_teams: Whether to include team names.
        :param str namespace: Namespace to use when querying for org entities.
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_matching_entities_with_http_info(prefix, **kwargs)  # noqa: E501
        else:
            (data) = self.get_matching_entities_with_http_info(prefix, **kwargs)  # noqa: E501
            return data

    def get_matching_entities_with_http_info(self, prefix, **kwargs):  # noqa: E501
        """get_matching_entities  # noqa: E501

        Get a list of entities that match the specified prefix.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_matching_entities_with_http_info(prefix, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str prefix:  (required)
        :param bool include_orgs: Whether to include orgs names.
        :param bool include_teams: Whether to include team names.
        :param str namespace: Namespace to use when querying for org entities.
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['prefix', 'include_orgs', 'include_teams', 'namespace']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_matching_entities" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'prefix' is set
        if self.api_client.client_side_validation and ('prefix' not in params or
                                                       params['prefix'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `prefix` when calling `get_matching_entities`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'prefix' in params:
            path_params['prefix'] = params['prefix']  # noqa: E501

        query_params = []
        if 'include_orgs' in params:
            query_params.append(('includeOrgs', params['include_orgs']))  # noqa: E501
        if 'include_teams' in params:
            query_params.append(('includeTeams', params['include_teams']))  # noqa: E501
        if 'namespace' in params:
            query_params.append(('namespace', params['namespace']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/api/v1/entities/{prefix}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
