# coding: utf-8

"""
    Quay Frontend

    This API allows you to perform many of the operations required to work with Quay repositories, users, and organizations.  # noqa: E501

    OpenAPI spec version: v1
    Contact: support@quay.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from quayio_sdk.api_client import ApiClient


class SecscanApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_repo_manifest_security(self, manifestref, repository, **kwargs):  # noqa: E501
        """get_repo_manifest_security  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_repo_manifest_security(manifestref, repository, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str manifestref: The digest of the manifest (required)
        :param str repository: The full path of the repository. e.g. namespace/name (required)
        :param bool vulnerabilities: Include vulnerabilities informations
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_repo_manifest_security_with_http_info(manifestref, repository, **kwargs)  # noqa: E501
        else:
            (data) = self.get_repo_manifest_security_with_http_info(manifestref, repository, **kwargs)  # noqa: E501
            return data

    def get_repo_manifest_security_with_http_info(self, manifestref, repository, **kwargs):  # noqa: E501
        """get_repo_manifest_security  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_repo_manifest_security_with_http_info(manifestref, repository, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str manifestref: The digest of the manifest (required)
        :param str repository: The full path of the repository. e.g. namespace/name (required)
        :param bool vulnerabilities: Include vulnerabilities informations
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['manifestref', 'repository', 'vulnerabilities']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_repo_manifest_security" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'manifestref' is set
        if self.api_client.client_side_validation and ('manifestref' not in params or
                                                       params['manifestref'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `manifestref` when calling `get_repo_manifest_security`")  # noqa: E501
        # verify the required parameter 'repository' is set
        if self.api_client.client_side_validation and ('repository' not in params or
                                                       params['repository'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `repository` when calling `get_repo_manifest_security`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'manifestref' in params:
            path_params['manifestref'] = params['manifestref']  # noqa: E501
        if 'repository' in params:
            path_params['repository'] = params['repository']  # noqa: E501

        query_params = []
        if 'vulnerabilities' in params:
            query_params.append(('vulnerabilities', params['vulnerabilities']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # Authentication setting
        auth_settings = ['oauth2_implicit']  # noqa: E501

        return self.api_client.call_api(
            '/api/v1/repository/{repository}/manifest/{manifestref}/security', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
