# coding: utf-8

"""
    Quay Frontend

    This API allows you to perform many of the operations required to work with Quay repositories, users, and organizations.  # noqa: E501

    OpenAPI spec version: v1
    Contact: support@quay.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from quayio_sdk.api_client import ApiClient


class TeamApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def delete_organization_team(self, orgname, teamname, **kwargs):  # noqa: E501
        """delete_organization_team  # noqa: E501

        Delete the specified team.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_organization_team(orgname, teamname, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str orgname: The name of the organization (required)
        :param str teamname: The name of the team (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.delete_organization_team_with_http_info(orgname, teamname, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_organization_team_with_http_info(orgname, teamname, **kwargs)  # noqa: E501
            return data

    def delete_organization_team_with_http_info(self, orgname, teamname, **kwargs):  # noqa: E501
        """delete_organization_team  # noqa: E501

        Delete the specified team.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_organization_team_with_http_info(orgname, teamname, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str orgname: The name of the organization (required)
        :param str teamname: The name of the team (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['orgname', 'teamname']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_organization_team" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'orgname' is set
        if self.api_client.client_side_validation and ('orgname' not in params or
                                                       params['orgname'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `orgname` when calling `delete_organization_team`")  # noqa: E501
        # verify the required parameter 'teamname' is set
        if self.api_client.client_side_validation and ('teamname' not in params or
                                                       params['teamname'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `teamname` when calling `delete_organization_team`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'orgname' in params:
            path_params['orgname'] = params['orgname']  # noqa: E501
        if 'teamname' in params:
            path_params['teamname'] = params['teamname']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # Authentication setting
        auth_settings = ['oauth2_implicit']  # noqa: E501

        return self.api_client.call_api(
            '/api/v1/organization/{orgname}/team/{teamname}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def delete_organization_team_member(self, membername, orgname, teamname, **kwargs):  # noqa: E501
        """delete_organization_team_member  # noqa: E501

        Delete a member of a team.          If the user is merely invited to join the team, then the invite is removed instead.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_organization_team_member(membername, orgname, teamname, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str membername: The username of the team member (required)
        :param str orgname: The name of the organization (required)
        :param str teamname: The name of the team (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.delete_organization_team_member_with_http_info(membername, orgname, teamname, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_organization_team_member_with_http_info(membername, orgname, teamname, **kwargs)  # noqa: E501
            return data

    def delete_organization_team_member_with_http_info(self, membername, orgname, teamname, **kwargs):  # noqa: E501
        """delete_organization_team_member  # noqa: E501

        Delete a member of a team.          If the user is merely invited to join the team, then the invite is removed instead.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_organization_team_member_with_http_info(membername, orgname, teamname, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str membername: The username of the team member (required)
        :param str orgname: The name of the organization (required)
        :param str teamname: The name of the team (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['membername', 'orgname', 'teamname']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_organization_team_member" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'membername' is set
        if self.api_client.client_side_validation and ('membername' not in params or
                                                       params['membername'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `membername` when calling `delete_organization_team_member`")  # noqa: E501
        # verify the required parameter 'orgname' is set
        if self.api_client.client_side_validation and ('orgname' not in params or
                                                       params['orgname'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `orgname` when calling `delete_organization_team_member`")  # noqa: E501
        # verify the required parameter 'teamname' is set
        if self.api_client.client_side_validation and ('teamname' not in params or
                                                       params['teamname'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `teamname` when calling `delete_organization_team_member`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'membername' in params:
            path_params['membername'] = params['membername']  # noqa: E501
        if 'orgname' in params:
            path_params['orgname'] = params['orgname']  # noqa: E501
        if 'teamname' in params:
            path_params['teamname'] = params['teamname']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # Authentication setting
        auth_settings = ['oauth2_implicit']  # noqa: E501

        return self.api_client.call_api(
            '/api/v1/organization/{orgname}/team/{teamname}/members/{membername}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def delete_team_member_email_invite(self, email, orgname, teamname, **kwargs):  # noqa: E501
        """delete_team_member_email_invite  # noqa: E501

        Delete an invite of an email address to join a team.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_team_member_email_invite(email, orgname, teamname, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str email:  (required)
        :param str orgname:  (required)
        :param str teamname:  (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.delete_team_member_email_invite_with_http_info(email, orgname, teamname, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_team_member_email_invite_with_http_info(email, orgname, teamname, **kwargs)  # noqa: E501
            return data

    def delete_team_member_email_invite_with_http_info(self, email, orgname, teamname, **kwargs):  # noqa: E501
        """delete_team_member_email_invite  # noqa: E501

        Delete an invite of an email address to join a team.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_team_member_email_invite_with_http_info(email, orgname, teamname, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str email:  (required)
        :param str orgname:  (required)
        :param str teamname:  (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['email', 'orgname', 'teamname']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_team_member_email_invite" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'email' is set
        if self.api_client.client_side_validation and ('email' not in params or
                                                       params['email'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `email` when calling `delete_team_member_email_invite`")  # noqa: E501
        # verify the required parameter 'orgname' is set
        if self.api_client.client_side_validation and ('orgname' not in params or
                                                       params['orgname'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `orgname` when calling `delete_team_member_email_invite`")  # noqa: E501
        # verify the required parameter 'teamname' is set
        if self.api_client.client_side_validation and ('teamname' not in params or
                                                       params['teamname'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `teamname` when calling `delete_team_member_email_invite`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'email' in params:
            path_params['email'] = params['email']  # noqa: E501
        if 'orgname' in params:
            path_params['orgname'] = params['orgname']  # noqa: E501
        if 'teamname' in params:
            path_params['teamname'] = params['teamname']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # Authentication setting
        auth_settings = ['oauth2_implicit']  # noqa: E501

        return self.api_client.call_api(
            '/api/v1/organization/{orgname}/team/{teamname}/invite/{email}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_organization_team_members(self, orgname, teamname, **kwargs):  # noqa: E501
        """get_organization_team_members  # noqa: E501

        Retrieve the list of members for the specified team.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_organization_team_members(orgname, teamname, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str orgname: The name of the organization (required)
        :param str teamname: The name of the team (required)
        :param bool include_pending: Whether to include pending members
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_organization_team_members_with_http_info(orgname, teamname, **kwargs)  # noqa: E501
        else:
            (data) = self.get_organization_team_members_with_http_info(orgname, teamname, **kwargs)  # noqa: E501
            return data

    def get_organization_team_members_with_http_info(self, orgname, teamname, **kwargs):  # noqa: E501
        """get_organization_team_members  # noqa: E501

        Retrieve the list of members for the specified team.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_organization_team_members_with_http_info(orgname, teamname, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str orgname: The name of the organization (required)
        :param str teamname: The name of the team (required)
        :param bool include_pending: Whether to include pending members
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['orgname', 'teamname', 'include_pending']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_organization_team_members" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'orgname' is set
        if self.api_client.client_side_validation and ('orgname' not in params or
                                                       params['orgname'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `orgname` when calling `get_organization_team_members`")  # noqa: E501
        # verify the required parameter 'teamname' is set
        if self.api_client.client_side_validation and ('teamname' not in params or
                                                       params['teamname'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `teamname` when calling `get_organization_team_members`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'orgname' in params:
            path_params['orgname'] = params['orgname']  # noqa: E501
        if 'teamname' in params:
            path_params['teamname'] = params['teamname']  # noqa: E501

        query_params = []
        if 'include_pending' in params:
            query_params.append(('includePending', params['include_pending']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # Authentication setting
        auth_settings = ['oauth2_implicit']  # noqa: E501

        return self.api_client.call_api(
            '/api/v1/organization/{orgname}/team/{teamname}/members', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_organization_team_permissions(self, orgname, teamname, **kwargs):  # noqa: E501
        """get_organization_team_permissions  # noqa: E501

        Returns the list of repository permissions for the org's team.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_organization_team_permissions(orgname, teamname, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str orgname: The name of the organization (required)
        :param str teamname: The name of the team (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_organization_team_permissions_with_http_info(orgname, teamname, **kwargs)  # noqa: E501
        else:
            (data) = self.get_organization_team_permissions_with_http_info(orgname, teamname, **kwargs)  # noqa: E501
            return data

    def get_organization_team_permissions_with_http_info(self, orgname, teamname, **kwargs):  # noqa: E501
        """get_organization_team_permissions  # noqa: E501

        Returns the list of repository permissions for the org's team.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_organization_team_permissions_with_http_info(orgname, teamname, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str orgname: The name of the organization (required)
        :param str teamname: The name of the team (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['orgname', 'teamname']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_organization_team_permissions" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'orgname' is set
        if self.api_client.client_side_validation and ('orgname' not in params or
                                                       params['orgname'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `orgname` when calling `get_organization_team_permissions`")  # noqa: E501
        # verify the required parameter 'teamname' is set
        if self.api_client.client_side_validation and ('teamname' not in params or
                                                       params['teamname'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `teamname` when calling `get_organization_team_permissions`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'orgname' in params:
            path_params['orgname'] = params['orgname']  # noqa: E501
        if 'teamname' in params:
            path_params['teamname'] = params['teamname']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/api/v1/organization/{orgname}/team/{teamname}/permissions', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def invite_team_member_email(self, email, orgname, teamname, **kwargs):  # noqa: E501
        """invite_team_member_email  # noqa: E501

        Invites an email address to an existing team.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.invite_team_member_email(email, orgname, teamname, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str email:  (required)
        :param str orgname:  (required)
        :param str teamname:  (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.invite_team_member_email_with_http_info(email, orgname, teamname, **kwargs)  # noqa: E501
        else:
            (data) = self.invite_team_member_email_with_http_info(email, orgname, teamname, **kwargs)  # noqa: E501
            return data

    def invite_team_member_email_with_http_info(self, email, orgname, teamname, **kwargs):  # noqa: E501
        """invite_team_member_email  # noqa: E501

        Invites an email address to an existing team.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.invite_team_member_email_with_http_info(email, orgname, teamname, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str email:  (required)
        :param str orgname:  (required)
        :param str teamname:  (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['email', 'orgname', 'teamname']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method invite_team_member_email" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'email' is set
        if self.api_client.client_side_validation and ('email' not in params or
                                                       params['email'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `email` when calling `invite_team_member_email`")  # noqa: E501
        # verify the required parameter 'orgname' is set
        if self.api_client.client_side_validation and ('orgname' not in params or
                                                       params['orgname'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `orgname` when calling `invite_team_member_email`")  # noqa: E501
        # verify the required parameter 'teamname' is set
        if self.api_client.client_side_validation and ('teamname' not in params or
                                                       params['teamname'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `teamname` when calling `invite_team_member_email`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'email' in params:
            path_params['email'] = params['email']  # noqa: E501
        if 'orgname' in params:
            path_params['orgname'] = params['orgname']  # noqa: E501
        if 'teamname' in params:
            path_params['teamname'] = params['teamname']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # Authentication setting
        auth_settings = ['oauth2_implicit']  # noqa: E501

        return self.api_client.call_api(
            '/api/v1/organization/{orgname}/team/{teamname}/invite/{email}', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def update_organization_team(self, orgname, teamname, body, **kwargs):  # noqa: E501
        """update_organization_team  # noqa: E501

        Update the org-wide permission for the specified team.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_organization_team(orgname, teamname, body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str orgname: The name of the organization (required)
        :param str teamname: The name of the team (required)
        :param TeamDescription body: Request body contents. (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.update_organization_team_with_http_info(orgname, teamname, body, **kwargs)  # noqa: E501
        else:
            (data) = self.update_organization_team_with_http_info(orgname, teamname, body, **kwargs)  # noqa: E501
            return data

    def update_organization_team_with_http_info(self, orgname, teamname, body, **kwargs):  # noqa: E501
        """update_organization_team  # noqa: E501

        Update the org-wide permission for the specified team.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_organization_team_with_http_info(orgname, teamname, body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str orgname: The name of the organization (required)
        :param str teamname: The name of the team (required)
        :param TeamDescription body: Request body contents. (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['orgname', 'teamname', 'body']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_organization_team" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'orgname' is set
        if self.api_client.client_side_validation and ('orgname' not in params or
                                                       params['orgname'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `orgname` when calling `update_organization_team`")  # noqa: E501
        # verify the required parameter 'teamname' is set
        if self.api_client.client_side_validation and ('teamname' not in params or
                                                       params['teamname'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `teamname` when calling `update_organization_team`")  # noqa: E501
        # verify the required parameter 'body' is set
        if self.api_client.client_side_validation and ('body' not in params or
                                                       params['body'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `body` when calling `update_organization_team`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'orgname' in params:
            path_params['orgname'] = params['orgname']  # noqa: E501
        if 'teamname' in params:
            path_params['teamname'] = params['teamname']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # Authentication setting
        auth_settings = ['oauth2_implicit']  # noqa: E501

        return self.api_client.call_api(
            '/api/v1/organization/{orgname}/team/{teamname}', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def update_organization_team_member(self, membername, orgname, teamname, **kwargs):  # noqa: E501
        """update_organization_team_member  # noqa: E501

        Adds or invites a member to an existing team.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_organization_team_member(membername, orgname, teamname, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str membername: The username of the team member (required)
        :param str orgname: The name of the organization (required)
        :param str teamname: The name of the team (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.update_organization_team_member_with_http_info(membername, orgname, teamname, **kwargs)  # noqa: E501
        else:
            (data) = self.update_organization_team_member_with_http_info(membername, orgname, teamname, **kwargs)  # noqa: E501
            return data

    def update_organization_team_member_with_http_info(self, membername, orgname, teamname, **kwargs):  # noqa: E501
        """update_organization_team_member  # noqa: E501

        Adds or invites a member to an existing team.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_organization_team_member_with_http_info(membername, orgname, teamname, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str membername: The username of the team member (required)
        :param str orgname: The name of the organization (required)
        :param str teamname: The name of the team (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['membername', 'orgname', 'teamname']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_organization_team_member" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'membername' is set
        if self.api_client.client_side_validation and ('membername' not in params or
                                                       params['membername'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `membername` when calling `update_organization_team_member`")  # noqa: E501
        # verify the required parameter 'orgname' is set
        if self.api_client.client_side_validation and ('orgname' not in params or
                                                       params['orgname'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `orgname` when calling `update_organization_team_member`")  # noqa: E501
        # verify the required parameter 'teamname' is set
        if self.api_client.client_side_validation and ('teamname' not in params or
                                                       params['teamname'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `teamname` when calling `update_organization_team_member`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'membername' in params:
            path_params['membername'] = params['membername']  # noqa: E501
        if 'orgname' in params:
            path_params['orgname'] = params['orgname']  # noqa: E501
        if 'teamname' in params:
            path_params['teamname'] = params['teamname']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # Authentication setting
        auth_settings = ['oauth2_implicit']  # noqa: E501

        return self.api_client.call_api(
            '/api/v1/organization/{orgname}/team/{teamname}/members/{membername}', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
