# coding: utf-8

"""
    Quay Frontend

    This API allows you to perform many of the operations required to work with Quay repositories, users, and organizations.  # noqa: E501

    OpenAPI spec version: v1
    Contact: support@quay.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from quayio_sdk.configuration import Configuration


class ApiError(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'status': 'int',
        'type': 'str',
        'detail': 'str',
        'title': 'str',
        'error_message': 'str',
        'error_type': 'str'
    }

    attribute_map = {
        'status': 'status',
        'type': 'type',
        'detail': 'detail',
        'title': 'title',
        'error_message': 'error_message',
        'error_type': 'error_type'
    }

    def __init__(self, status=None, type=None, detail=None, title=None, error_message=None, error_type=None, _configuration=None):  # noqa: E501
        """ApiError - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._status = None
        self._type = None
        self._detail = None
        self._title = None
        self._error_message = None
        self._error_type = None
        self.discriminator = None

        self.status = status
        self.type = type
        if detail is not None:
            self.detail = detail
        self.title = title
        if error_message is not None:
            self.error_message = error_message
        if error_type is not None:
            self.error_type = error_type

    @property
    def status(self):
        """Gets the status of this ApiError.  # noqa: E501

        Status code of the response.  # noqa: E501

        :return: The status of this ApiError.  # noqa: E501
        :rtype: int
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this ApiError.

        Status code of the response.  # noqa: E501

        :param status: The status of this ApiError.  # noqa: E501
        :type: int
        """
        if self._configuration.client_side_validation and status is None:
            raise ValueError("Invalid value for `status`, must not be `None`")  # noqa: E501

        self._status = status

    @property
    def type(self):
        """Gets the type of this ApiError.  # noqa: E501

        Reference to the type of the error.  # noqa: E501

        :return: The type of this ApiError.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this ApiError.

        Reference to the type of the error.  # noqa: E501

        :param type: The type of this ApiError.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and type is None:
            raise ValueError("Invalid value for `type`, must not be `None`")  # noqa: E501

        self._type = type

    @property
    def detail(self):
        """Gets the detail of this ApiError.  # noqa: E501

        Details about the specific instance of the error.  # noqa: E501

        :return: The detail of this ApiError.  # noqa: E501
        :rtype: str
        """
        return self._detail

    @detail.setter
    def detail(self, detail):
        """Sets the detail of this ApiError.

        Details about the specific instance of the error.  # noqa: E501

        :param detail: The detail of this ApiError.  # noqa: E501
        :type: str
        """

        self._detail = detail

    @property
    def title(self):
        """Gets the title of this ApiError.  # noqa: E501

        Unique error code to identify the type of error.  # noqa: E501

        :return: The title of this ApiError.  # noqa: E501
        :rtype: str
        """
        return self._title

    @title.setter
    def title(self, title):
        """Sets the title of this ApiError.

        Unique error code to identify the type of error.  # noqa: E501

        :param title: The title of this ApiError.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and title is None:
            raise ValueError("Invalid value for `title`, must not be `None`")  # noqa: E501

        self._title = title

    @property
    def error_message(self):
        """Gets the error_message of this ApiError.  # noqa: E501

        Deprecated; alias for detail  # noqa: E501

        :return: The error_message of this ApiError.  # noqa: E501
        :rtype: str
        """
        return self._error_message

    @error_message.setter
    def error_message(self, error_message):
        """Sets the error_message of this ApiError.

        Deprecated; alias for detail  # noqa: E501

        :param error_message: The error_message of this ApiError.  # noqa: E501
        :type: str
        """

        self._error_message = error_message

    @property
    def error_type(self):
        """Gets the error_type of this ApiError.  # noqa: E501

        Deprecated; alias for detail  # noqa: E501

        :return: The error_type of this ApiError.  # noqa: E501
        :rtype: str
        """
        return self._error_type

    @error_type.setter
    def error_type(self, error_type):
        """Sets the error_type of this ApiError.

        Deprecated; alias for detail  # noqa: E501

        :param error_type: The error_type of this ApiError.  # noqa: E501
        :type: str
        """

        self._error_type = error_type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ApiError, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ApiError):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ApiError):
            return True

        return self.to_dict() != other.to_dict()
