# coding: utf-8

"""
    Quay Frontend

    This API allows you to perform many of the operations required to work with Quay repositories, users, and organizations.  # noqa: E501

    OpenAPI spec version: v1
    Contact: support@quay.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from quayio_sdk.configuration import Configuration


class ApiErrorDescription(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'type': 'str',
        'title': 'str',
        'description': 'str'
    }

    attribute_map = {
        'type': 'type',
        'title': 'title',
        'description': 'description'
    }

    def __init__(self, type=None, title=None, description=None, _configuration=None):  # noqa: E501
        """ApiErrorDescription - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._type = None
        self._title = None
        self._description = None
        self.discriminator = None

        self.type = type
        self.title = title
        self.description = description

    @property
    def type(self):
        """Gets the type of this ApiErrorDescription.  # noqa: E501

        A reference to the error type resource  # noqa: E501

        :return: The type of this ApiErrorDescription.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this ApiErrorDescription.

        A reference to the error type resource  # noqa: E501

        :param type: The type of this ApiErrorDescription.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and type is None:
            raise ValueError("Invalid value for `type`, must not be `None`")  # noqa: E501

        self._type = type

    @property
    def title(self):
        """Gets the title of this ApiErrorDescription.  # noqa: E501

        The title of the error. Can be used to uniquely identify the kind of error.  # noqa: E501

        :return: The title of this ApiErrorDescription.  # noqa: E501
        :rtype: str
        """
        return self._title

    @title.setter
    def title(self, title):
        """Sets the title of this ApiErrorDescription.

        The title of the error. Can be used to uniquely identify the kind of error.  # noqa: E501

        :param title: The title of this ApiErrorDescription.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and title is None:
            raise ValueError("Invalid value for `title`, must not be `None`")  # noqa: E501
        allowed_values = ["external_service_timeout", "invalid_request", "invalid_response", "invalid_token", "expired_token", "insufficient_scope", "fresh_login_required", "exceeds_license", "not_found", "downstream_issue"]  # noqa: E501
        if (self._configuration.client_side_validation and
                title not in allowed_values):
            raise ValueError(
                "Invalid value for `title` ({0}), must be one of {1}"  # noqa: E501
                .format(title, allowed_values)
            )

        self._title = title

    @property
    def description(self):
        """Gets the description of this ApiErrorDescription.  # noqa: E501

        A more detailed description of the error that may include help for fixing the issue.  # noqa: E501

        :return: The description of this ApiErrorDescription.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this ApiErrorDescription.

        A more detailed description of the error that may include help for fixing the issue.  # noqa: E501

        :param description: The description of this ApiErrorDescription.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and description is None:
            raise ValueError("Invalid value for `description`, must not be `None`")  # noqa: E501

        self._description = description

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ApiErrorDescription, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ApiErrorDescription):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ApiErrorDescription):
            return True

        return self.to_dict() != other.to_dict()
