# coding: utf-8

"""
    Quay Frontend

    This API allows you to perform many of the operations required to work with Quay repositories, users, and organizations.  # noqa: E501

    OpenAPI spec version: v1
    Contact: support@quay.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from quayio_sdk.configuration import Configuration


class CreateRobot(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'description': 'str',
        'unstructured_metadata': 'object'
    }

    attribute_map = {
        'description': 'description',
        'unstructured_metadata': 'unstructured_metadata'
    }

    def __init__(self, description=None, unstructured_metadata=None, _configuration=None):  # noqa: E501
        """CreateRobot - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._description = None
        self._unstructured_metadata = None
        self.discriminator = None

        if description is not None:
            self.description = description
        if unstructured_metadata is not None:
            self.unstructured_metadata = unstructured_metadata

    @property
    def description(self):
        """Gets the description of this CreateRobot.  # noqa: E501

        Optional text description for the robot  # noqa: E501

        :return: The description of this CreateRobot.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this CreateRobot.

        Optional text description for the robot  # noqa: E501

        :param description: The description of this CreateRobot.  # noqa: E501
        :type: str
        """
        if (self._configuration.client_side_validation and
                description is not None and len(description) > 255):
            raise ValueError("Invalid value for `description`, length must be less than or equal to `255`")  # noqa: E501

        self._description = description

    @property
    def unstructured_metadata(self):
        """Gets the unstructured_metadata of this CreateRobot.  # noqa: E501

        Optional unstructured metadata for the robot  # noqa: E501

        :return: The unstructured_metadata of this CreateRobot.  # noqa: E501
        :rtype: object
        """
        return self._unstructured_metadata

    @unstructured_metadata.setter
    def unstructured_metadata(self, unstructured_metadata):
        """Sets the unstructured_metadata of this CreateRobot.

        Optional unstructured metadata for the robot  # noqa: E501

        :param unstructured_metadata: The unstructured_metadata of this CreateRobot.  # noqa: E501
        :type: object
        """

        self._unstructured_metadata = unstructured_metadata

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CreateRobot, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateRobot):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CreateRobot):
            return True

        return self.to_dict() != other.to_dict()
