# coding: utf-8

"""
    Quay Frontend

    This API allows you to perform many of the operations required to work with Quay repositories, users, and organizations.  # noqa: E501

    OpenAPI spec version: v1
    Contact: support@quay.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from quayio_sdk.configuration import Configuration


class NewRepo(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'repository': 'str',
        'visibility': 'str',
        'namespace': 'str',
        'description': 'str'
    }

    attribute_map = {
        'repository': 'repository',
        'visibility': 'visibility',
        'namespace': 'namespace',
        'description': 'description'
    }

    def __init__(self, repository=None, visibility=None, namespace=None, description=None, _configuration=None):  # noqa: E501
        """NewRepo - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._repository = None
        self._visibility = None
        self._namespace = None
        self._description = None
        self.discriminator = None

        self.repository = repository
        self.visibility = visibility
        if namespace is not None:
            self.namespace = namespace
        self.description = description

    @property
    def repository(self):
        """Gets the repository of this NewRepo.  # noqa: E501

        Repository name  # noqa: E501

        :return: The repository of this NewRepo.  # noqa: E501
        :rtype: str
        """
        return self._repository

    @repository.setter
    def repository(self, repository):
        """Sets the repository of this NewRepo.

        Repository name  # noqa: E501

        :param repository: The repository of this NewRepo.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and repository is None:
            raise ValueError("Invalid value for `repository`, must not be `None`")  # noqa: E501

        self._repository = repository

    @property
    def visibility(self):
        """Gets the visibility of this NewRepo.  # noqa: E501

        Visibility which the repository will start with  # noqa: E501

        :return: The visibility of this NewRepo.  # noqa: E501
        :rtype: str
        """
        return self._visibility

    @visibility.setter
    def visibility(self, visibility):
        """Sets the visibility of this NewRepo.

        Visibility which the repository will start with  # noqa: E501

        :param visibility: The visibility of this NewRepo.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and visibility is None:
            raise ValueError("Invalid value for `visibility`, must not be `None`")  # noqa: E501
        allowed_values = ["public", "private"]  # noqa: E501
        if (self._configuration.client_side_validation and
                visibility not in allowed_values):
            raise ValueError(
                "Invalid value for `visibility` ({0}), must be one of {1}"  # noqa: E501
                .format(visibility, allowed_values)
            )

        self._visibility = visibility

    @property
    def namespace(self):
        """Gets the namespace of this NewRepo.  # noqa: E501

        Namespace in which the repository should be created. If omitted, the username of the caller is used  # noqa: E501

        :return: The namespace of this NewRepo.  # noqa: E501
        :rtype: str
        """
        return self._namespace

    @namespace.setter
    def namespace(self, namespace):
        """Sets the namespace of this NewRepo.

        Namespace in which the repository should be created. If omitted, the username of the caller is used  # noqa: E501

        :param namespace: The namespace of this NewRepo.  # noqa: E501
        :type: str
        """

        self._namespace = namespace

    @property
    def description(self):
        """Gets the description of this NewRepo.  # noqa: E501

        Markdown encoded description for the repository  # noqa: E501

        :return: The description of this NewRepo.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this NewRepo.

        Markdown encoded description for the repository  # noqa: E501

        :param description: The description of this NewRepo.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and description is None:
            raise ValueError("Invalid value for `description`, must not be `None`")  # noqa: E501

        self._description = description

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(NewRepo, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NewRepo):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, NewRepo):
            return True

        return self.to_dict() != other.to_dict()
