# coding: utf-8

"""
    Quay Frontend

    This API allows you to perform many of the operations required to work with Quay repositories, users, and organizations.  # noqa: E501

    OpenAPI spec version: v1
    Contact: support@quay.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from quayio_sdk.configuration import Configuration


class RunParameters(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'branch_name': 'str',
        'commit_sha': 'str'
    }

    attribute_map = {
        'branch_name': 'branch_name',
        'commit_sha': 'commit_sha'
    }

    def __init__(self, branch_name=None, commit_sha=None, _configuration=None):  # noqa: E501
        """RunParameters - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._branch_name = None
        self._commit_sha = None
        self.discriminator = None

        if branch_name is not None:
            self.branch_name = branch_name
        if commit_sha is not None:
            self.commit_sha = commit_sha

    @property
    def branch_name(self):
        """Gets the branch_name of this RunParameters.  # noqa: E501

        (SCM only) If specified, the name of the branch to build.  # noqa: E501

        :return: The branch_name of this RunParameters.  # noqa: E501
        :rtype: str
        """
        return self._branch_name

    @branch_name.setter
    def branch_name(self, branch_name):
        """Sets the branch_name of this RunParameters.

        (SCM only) If specified, the name of the branch to build.  # noqa: E501

        :param branch_name: The branch_name of this RunParameters.  # noqa: E501
        :type: str
        """

        self._branch_name = branch_name

    @property
    def commit_sha(self):
        """Gets the commit_sha of this RunParameters.  # noqa: E501

        (Custom Only) If specified, the ref/SHA1 used to checkout a git repository.  # noqa: E501

        :return: The commit_sha of this RunParameters.  # noqa: E501
        :rtype: str
        """
        return self._commit_sha

    @commit_sha.setter
    def commit_sha(self, commit_sha):
        """Sets the commit_sha of this RunParameters.

        (Custom Only) If specified, the ref/SHA1 used to checkout a git repository.  # noqa: E501

        :param commit_sha: The commit_sha of this RunParameters.  # noqa: E501
        :type: str
        """

        self._commit_sha = commit_sha

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(RunParameters, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RunParameters):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, RunParameters):
            return True

        return self.to_dict() != other.to_dict()
