# coding: utf-8

"""
    Quay Frontend

    This API allows you to perform many of the operations required to work with Quay repositories, users, and organizations.  # noqa: E501

    OpenAPI spec version: v1
    Contact: support@quay.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from quayio_sdk.configuration import Configuration


class UpdateUser(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'password': 'str',
        'invoice_email': 'bool',
        'email': 'str',
        'tag_expiration_s': 'int',
        'username': 'str'
    }

    attribute_map = {
        'password': 'password',
        'invoice_email': 'invoice_email',
        'email': 'email',
        'tag_expiration_s': 'tag_expiration_s',
        'username': 'username'
    }

    def __init__(self, password=None, invoice_email=None, email=None, tag_expiration_s=None, username=None, _configuration=None):  # noqa: E501
        """UpdateUser - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._password = None
        self._invoice_email = None
        self._email = None
        self._tag_expiration_s = None
        self._username = None
        self.discriminator = None

        if password is not None:
            self.password = password
        if invoice_email is not None:
            self.invoice_email = invoice_email
        if email is not None:
            self.email = email
        if tag_expiration_s is not None:
            self.tag_expiration_s = tag_expiration_s
        if username is not None:
            self.username = username

    @property
    def password(self):
        """Gets the password of this UpdateUser.  # noqa: E501

        The user's password  # noqa: E501

        :return: The password of this UpdateUser.  # noqa: E501
        :rtype: str
        """
        return self._password

    @password.setter
    def password(self, password):
        """Sets the password of this UpdateUser.

        The user's password  # noqa: E501

        :param password: The password of this UpdateUser.  # noqa: E501
        :type: str
        """

        self._password = password

    @property
    def invoice_email(self):
        """Gets the invoice_email of this UpdateUser.  # noqa: E501

        Whether the user desires to receive an invoice email.  # noqa: E501

        :return: The invoice_email of this UpdateUser.  # noqa: E501
        :rtype: bool
        """
        return self._invoice_email

    @invoice_email.setter
    def invoice_email(self, invoice_email):
        """Sets the invoice_email of this UpdateUser.

        Whether the user desires to receive an invoice email.  # noqa: E501

        :param invoice_email: The invoice_email of this UpdateUser.  # noqa: E501
        :type: bool
        """

        self._invoice_email = invoice_email

    @property
    def email(self):
        """Gets the email of this UpdateUser.  # noqa: E501

        The user's email address  # noqa: E501

        :return: The email of this UpdateUser.  # noqa: E501
        :rtype: str
        """
        return self._email

    @email.setter
    def email(self, email):
        """Sets the email of this UpdateUser.

        The user's email address  # noqa: E501

        :param email: The email of this UpdateUser.  # noqa: E501
        :type: str
        """

        self._email = email

    @property
    def tag_expiration_s(self):
        """Gets the tag_expiration_s of this UpdateUser.  # noqa: E501

        The number of seconds for tag expiration  # noqa: E501

        :return: The tag_expiration_s of this UpdateUser.  # noqa: E501
        :rtype: int
        """
        return self._tag_expiration_s

    @tag_expiration_s.setter
    def tag_expiration_s(self, tag_expiration_s):
        """Sets the tag_expiration_s of this UpdateUser.

        The number of seconds for tag expiration  # noqa: E501

        :param tag_expiration_s: The tag_expiration_s of this UpdateUser.  # noqa: E501
        :type: int
        """
        if (self._configuration.client_side_validation and
                tag_expiration_s is not None and tag_expiration_s < 0):  # noqa: E501
            raise ValueError("Invalid value for `tag_expiration_s`, must be a value greater than or equal to `0`")  # noqa: E501

        self._tag_expiration_s = tag_expiration_s

    @property
    def username(self):
        """Gets the username of this UpdateUser.  # noqa: E501

        The user's username  # noqa: E501

        :return: The username of this UpdateUser.  # noqa: E501
        :rtype: str
        """
        return self._username

    @username.setter
    def username(self, username):
        """Sets the username of this UpdateUser.

        The user's username  # noqa: E501

        :param username: The username of this UpdateUser.  # noqa: E501
        :type: str
        """

        self._username = username

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(UpdateUser, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UpdateUser):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, UpdateUser):
            return True

        return self.to_dict() != other.to_dict()
